//+------------------------------------------------------------------+
//|                                                       LukaEA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots=0.22;

int MagicNumber = 13452;

bool  Set20=false,
      Set40=false,
      Set60=false,
      Set80=false,
      Set100=false,
      Set120=false,
      Set150=false;
      
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   MagicNumber=subGenerateMagicNumber(MagicNumber,Symbol());
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   
   
   int      i,
            diff;
        
   double   sl,tp;
   
   for (i=0;i<=OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         
         if (OrderSymbol()==Symbol() && OrderType()<=OP_SELL  && OrderLots()==Lots)
            {  
               
               if (OrderType()==OP_BUY)
                  {
                       diff=(Bid-OrderOpenPrice())/Point;
                        if (diff>=220 && Set20==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    openLimit(OP_BUYLIMIT,OrderOpenPrice());
                                 } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    openLimit(OP_BUYLIMIT,OrderOpenPrice());
                                 }   
                             Set20=true;
                              if (Set20==true)                      
                                     {
                                      
                                  Alert ("Stop loss 22pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                  
                              break;                           
                                     }
                           } 
                           
                           if (diff>=440 && Set40==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set40=true;
                              if (Set40==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 44pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                           } 
                           
                           if (diff>=660 && Set60==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set60=true;
                              if (Set60==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 66pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                           } 
                           if (diff>=880 && Set80==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set80=true;
                              if (Set80==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 88pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                           } 
                           if (diff>=1100 && Set100==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set100=true;
                              if (Set100==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 110pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                           } 
                           if (diff>=1220 && Set120==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set120=true;
                              if (Set120==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 122pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                           } 
                           if (diff>=1550 && Set150==false)
                           {  
                              sl=OrderOpenPrice()+(diff*Point/2);
                              tp=Bid+(1000*Point);
                              if(OrderStopLoss()>0 && sl>OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                       } 
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                  }   
                              Set150=true;
                              if (Set150==true)                      // Got it! :)
                                     {
                                 Alert ("Stop loss 155pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                 break;                           // From modification cycle.
                                     }
                            
                         
                       // Pregleda ce je pozicija na true ter ce pride do stoplossa ali  open price!
                  
                      if(Set20==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set20=false;
                                if (Set20==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set20 je False");
                                 break;                           
                                     }
                               }
                             }
                          
                       if(Set40==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set40=false;
                                if (Set40==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set40 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                        
                        if(Set60==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set60=false;
                                if (Set60==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set60 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                            
                        if(Set80==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set80=false;
                                if (Set80==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set80 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                            
                         if(Set100==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set100=false;
                                if (Set100==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set100 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
                            
                         if(Set120==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set120=false;
                                if (Set120==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set120 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
                            
                          if(Set150==true)
                            {
                           
                            if (Bid<=sl || Bid<=OrderOpenPrice())                   
                              {
                                Set150=false;
                                if (Set150==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set150 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
                                        
                     }
                   } 
               if (OrderType()==OP_SELL)
                  {  
                     
                     diff=(OrderOpenPrice()-Ask)/Point;
                     
                        if (diff>=220 && Set20==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    openLimit(OP_SELLLIMIT,OrderOpenPrice());
                                 }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    openLimit(OP_SELLLIMIT,OrderOpenPrice());
                                 } 
                               Set20=true;
                              if (Set20==true)                      // Got it! :)
                                     {
                                         
                                  Alert ("Stop loss 22pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                              break;                           // From modification cycle.
                                     }
                           } 
                           
                           if (diff>=440 && Set40==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set40=true;
                                   if (Set40==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 44pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                           } 
                           
                           if (diff>=660 && Set60==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set60=true;
                                   if (Set60==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 66pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                           } 
                           
                           if (diff>=880 && Set80==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set80=true;
                                   if (Set80==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 88pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                           } 
                           
                            if (diff>=1100 && Set100==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set100=true;
                                   if (Set100==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 110pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                           }
                           
                            if (diff>=1220 && Set120==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set120=true;
                                   if (Set120==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 122pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                           }
                           
                            if (diff>=1550 && Set150==false)
                           {  
                              sl=OrderOpenPrice()-(diff*Point/2);
                              tp=Bid-(1000*Point);
                              if(OrderStopLoss()>0 && sl<OrderStopLoss())
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                    }   
                              if(OrderStopLoss()==0)
                                 {
                                    OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,CLR_NONE);
                                   } 
                               Set150=true;
                                   if (Set150==true)                      // Got it! :)
                                     {
                                   Alert ("Stop loss 155pipov! Par: ",Symbol(),"   Stop loss na:  ",sl);
                                   break;                           // From modification cycle.
                                     }
                   
                           
                         
                  
                         // Pregleda ce je pozicija na true ter ce pride do stoplossa ali  open price!
                  
                      if(Set20==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set20=false;
                                if (Set20==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set20 je False");
                                 break;                           
                                     }
                               }
                             }
                          
                       if(Set40==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set40=false;
                                if (Set40==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set40 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                        
                        if(Set60==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set60=false;
                                if (Set60==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set60 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                            
                        if(Set80==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set80=false;
                                if (Set80==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set80 je False");
                                 break;                           
                                     }
                              }   
                     
                            } 
                            
                         if(Set100==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set100=false;
                                if (Set100==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set100 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
                            
                         if(Set120==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set120=false;
                                if (Set120==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set120 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
                            
                          if(Set150==true)
                            {
                           
                            if (Ask<=sl || Ask<=OrderOpenPrice())                   
                              {
                                Set150=false;
                                if (Set150==false)                      
                                     {
                                 Alert ("Cena je dosegla SL na paru:  ",Symbol(),"Set150 je False");
                                 break;                           
                                     }
                              }   
                     
                            }
               
                          
                   }
                           
                  }
                  
                    
            }
         
      }                         
                            
                
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void openLimit(int type,double price)
{
   int   i,
         total=0;
   
   
   for (i=0;i<=OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            
            if(OrderType()==type  &&
            OrderMagicNumber()==MagicNumber) total++;
      }      
      
   if (total<1)
      {
         OrderSend(Symbol(),type,Lots,price,3,0,0,NULL,MagicNumber,0,CLR_NONE);
      }         
      
}      
      
int subGenerateMagicNumber(int MagicNumber, string symbol)
{
   int isymbol = 0;
   if (symbol == "EURUSD")       isymbol = 1;
   else if (symbol == "GBPUSD")  isymbol = 2;
   else if (symbol == "USDJPY")  isymbol = 3;
   else if (symbol == "USDCHF")  isymbol = 4;
   else if (symbol == "AUDUSD")  isymbol = 5;
   else if (symbol == "USDCAD")  isymbol = 6;
   else if (symbol == "EURGBP")  isymbol = 7;
   else if (symbol == "EURJPY")  isymbol = 8;
   else if (symbol == "EURCHF")  isymbol = 9;
   else if (symbol == "EURAUD")  isymbol = 10;
   else if (symbol == "EURCAD")  isymbol = 11;
   else if (symbol == "GBPUSD")  isymbol = 12;
   else if (symbol == "GBPJPY")  isymbol = 13;
   else if (symbol == "GBPCHF")  isymbol = 14;
   else if (symbol == "GBPAUD")  isymbol = 15;
   else if (symbol == "GBPCAD")  isymbol = 16;
   else if (symbol == "XAUUSD")  isymbol = 17;
   else                          isymbol = 18;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol)));
}    




